Subject: Linux Frequently Asked Questions with Answers
From: [email-masked] (Ian Jackson)
Date: Mon, 3 Jan 1994 17:07:23 GMT
Newsgroups: comp.os.linux.announce,comp.os.linux.help,comp.answers,news.answers

Archive-Name: linux/faq
Last-Modified: 03 Jan 1994

This is the list of Frequently Asked Questions about Linux, the free Unix
for 386/486 [see Q1.1 `What is Linux ?' for more details].  It should be
read in conjunction with the HOWTO documents, which are available in
   ftp.funet.fi (128.214.6.100)   /pub/OS/Linux/doc/HOWTO
   tsx-11.mit.edu (18.172.1.2)    /pub/linux/docs/HOWTO
   sunsite.unc.edu (152.2.22.81)  /pub/Linux/docs/HOWTO
and mirror sites thereof -- see Q2.4 `Where can I get Linux material by
FTP ?'.  See Q2.1 `Where can I get the HOWTOs and other documentation ?'
for a list of the HOWTOs and more information.  The INFO-SHEET and
META-FAQ, found in the same place, also list other sources of Linux
information.

The Linux Documentation Project documentation is available on
sunsite.unc.edu in /pub/Linux/docs/LDP.  These documents (more are in
preparation) are invaluable to the newcomer or for use as a reference
work.

Please check out these documents and this FAQ, especially Q9.1 `You still
haven't answered my question !', before posting your question to the
newsgroup comp.os.linux.help.

You can skip to a particular question by searching for `Question n.n'.
See Q10.2 `Formats in which this FAQ is available' for details of where to
get the PostScript and Emacs Info versions of this document.

===============================================================================

Index

 Section 1.  Introduction and General Information
 Q1.1        What is Linux ?
 Q1.2        What software does it support ?
 Q1.3        Does it run on my computer ?  What hardware is supported ?
 Q1.4        How much hard disk space does Linux need ?
 Q1.5        Is Linux PD ?  Copyrighted ?
 Q1.6        How should I pronounce Linux ?

 Section 2.  Network sources and resources
 Q2.1        Where can I get the HOWTOs and other documentation ?
 Q2.2        What newsgroups are there for Linux ?
 Q2.3        How do I install Linux ?
 Q2.4        Where can I get Linux material by FTP ?
 Q2.5        I don't have FTP access.  Where do I get Linux ?
 Q2.6        I don't have Usenet access.  Where do I get information ?
 Q2.7        What's this mailing list thing at niksula.hut.fi ?
 Q2.8        Are the newsgroups archived anywhere ?

 Section 3.  Compatibility with other operating systems
 Q3.1        Can Linux coexist with DOS ?  OS/2 ?  386BSD ?  Minix ?
 Q3.2        How do I access files on my DOS partition or floppy ?
 Q3.3        Can I use my Stacked/DBLSPC/etc. DOS drive ?
 Q3.4        Can I access OS/2 HPFS, BSD FFS, Mac, Amiga, etc filesystems ?
 Q3.5        Can I run Microsoft Windows programs under Linux ?
 Q3.6        How can I boot Linux from OS/2's Boot Manager ?

 Section 4.  Linux's handling of filesystems, disks and drives
 Q4.1        How do I format and create a filesystem on a floppy ?
 Q4.2        I get nasty messages about inodes, blocks, and the suchlike
 Q4.3        My swap area isn't working.
 Q4.4        How can I have more than 16Mb of swap ?
 Q4.5        How do I remove LILO so my system boots DOS again ?
 Q4.6        Why can't I use fdformat except as root ?
 Q4.7        Is there something like Stacker or Doublespace for Linux ?

 Section 5.  Porting, compiling and obtaining programs
 Q5.1        What is ld.so and where do I get it ?
 Q5.2        Has anyone ported / compiled / written XXX for Linux ?
 Q5.3        How do I port XXX to Linux ?
 Q5.4        Can I use code or a compiler compiled for a 486 on my 386 ?
 Q5.5        GCC sometimes uses huge amounts of virtual memory and thrashes
 Q5.6        What does gcc -O6 do ?
 Q5.7        Where are <linux/*.h> and <asm/*.h> ?
 Q5.8        I get errors when I try to compile the kernel.

 Section 6.  Miscellaneous questions and problems
 Q6.1        Setuid scripts don't seem to work.
 Q6.2        Free memory as reported by free keeps shrinking.
 Q6.3        What is a BogoMip ?
 Q6.4        How do I set the timezone ?
 Q6.5        What version of Linux and what machine name am I using ?
 Q6.6        When I add more memory it slows to a crawl.
 Q6.7        Some programs (e.g. xdm) won't let me log in.
 Q6.8        Some programs let me log in with no password.
 Q6.9        My machine runs very slowly when I run GCC / X / ...
 Q6.10       I can only log in as root.
 Q6.11       How do I stop producing core files ?
 Q6.12       My screen is all full of weird characters instead of letters.
 Q6.13       What is a .gz file ? And a .tgz ? And ... ?
 Q6.14       I have screwed up my system and can't log in to fix it.
 Q6.15       How do I upgrade my kernel ?
 Q6.16       Can I have more than 3 serial ports by sharing interrupts ?
 Q6.17       Emacs just dumps core.
 Q6.18       How do I make a bootable floppy ?
 Q6.19       How do I remap my keyboard to UK, French, etc. ?

 Section 7.  Frequently Encountered Error messages
 Q7.1        INET: Warning: old style ioctl(IP_SET_DEV) called!
 Q7.2        ld: unrecognized option '-m486'
 Q7.3        GCC says Internal compiler error
 Q7.4        make says Error 139
 Q7.5        df says Cannot read table of mounted filesystems
 Q7.6        shell-init: permission denied when I log in.
 Q7.7        No utmp entry.  You must exec ... when I log in.
 Q7.8        EXT2-fs: warning: mounting unchecked filesystem
 Q7.9        fdisk says cannot use nnn sectors of this partition
 Q7.10       fdisk says partition n has an odd number of sectors

 Section 8.  X Windows
 Q8.1        Does Linux support X Windows ?
 Q8.2        Where can I get an XConfig for my video card and monitor ?
 Q8.3        I can't get X Windows to work right.

 Section 9.  How to get further assistance
 Q9.1        You still haven't answered my question !
 Q9.2        What to put in a posting to comp.os.linux.help

 Section 10. Administrative information and acknowledgements
 Q10.1       Feedback is invited
 Q10.2       Formats in which this FAQ is available
 Q10.3       Authorship and acknowledgements

===============================================================================

Section 1.  Introduction and General Information

 Q1.1        What is Linux ?
 Q1.2        What software does it support ?
 Q1.3        Does it run on my computer ?  What hardware is supported ?
 Q1.4        How much hard disk space does Linux need ?
 Q1.5        Is Linux PD ?  Copyrighted ?
 Q1.6        How should I pronounce Linux ?

-------------------------------------------------------------------------------

Question 1.1.  What is Linux ?

Linux is a Unix clone for 386/486-based PCs written from scratch by Linus
Torvalds with assistance from a loosely-knit team of hackers across the
Net.  It aims towards POSIX compliance.

It has all the features you would expect in a modern fully-fledged Unix,
including true multitasking, virtual memory, shared libraries, demand
loading, shared copy-on-write executables, proper memory management and
TCP/IP networking.

It uses the hardware features of the 386 processor family (TSS segments et
al) to implement these features.

Linux is still considered to be in beta testing; due to the rapid pace of
development new bugs are often introduced.  Despite this, Linux is very
stable if you don't always immediately use the latest alpha-release kernel
software.

See the Linux INFO-SHEET [Q2.1 `Where can I get the HOWTOs and other
documentation ?'] for more details.

It is distributed under the GNU General Public License - see Q1.5 `Is
Linux PD ?  Copyrighted ?' for more details.

-------------------------------------------------------------------------------

Question 1.2.  What software does it support ?

Linux has GCC, Emacs, X-Windows, TCP/IP, all the standard Unix utilities
and all the hundreds of programs that people have compiled or ported for
it.

There is a DOS emulator [Q3.1 `Can Linux coexist with DOS ?  OS/2 ?
386BSD ?  Minix ?'] and work is progressing on a facilities to allow SVR4
ELF, SVR3.2 COFF and Microsoft Windows binaries [Q3.5 `Can I run Microsoft
Windows programs under Linux ?'] to be run under Linux and X Windows.

For more information see the INFO-SHEET, which is one of the the HOWTOs
--- see above, or Q2.1 `Where can I get the HOWTOs and other documentation
?'.  See also Q5.3 `How do I port XXX to Linux ?'.

-------------------------------------------------------------------------------

Question 1.3.  Does it run on my computer ?  What hardware is supported ?

You need a 386 or 486, with at least 2Mb of RAM and a single floppy, to
try it out.  To do anything useful more RAM and a hard disk are required.
Reportedly Linux also works on a Pentium.

Linux doesn't currently work on machines using MCA (IBM's proprietary
bus), because of lack of available documentation.  You may be able to it
to work if you your hard disk is on certain kinds of controller (some SCSI
controllers work, I understand), but you're on your own.

It should work with VESA local bus machines, provided that the local bus
cards really are equivalent to the equivalent ISA ones.  Linux is reported
to run on 386/486-based laptops, with X on most of them.

For details of exactly which PC's, video cards, disk controllers, etc.
work see the INFO-SHEET and the Hardware Compatibility List [Q2.1 `Where
can I get the HOWTOs and other documentation ?'].

Linux will never run on a 286, because it uses task-switching and memory
management facilities only found on 386/486 processors.

A project is underway to port Linux to suitable 68000-series based
systems, but this is still at a very early stage of development.  Don't
post asking about it unless you think you can contribute to it, and don't
hold your breath.

-------------------------------------------------------------------------------

Question 1.4.  How much hard disk space does Linux need ?

10Mb for a very minimal installation, suitable for trying it out and not
much else.

You can squeeze a more complete installation including X Windows into
80Mb.  The SLS 1.03 distribution (which I would recommend you stay well
clear of - it has a number of serious and annoying bugs) takes around
100Mb.

-------------------------------------------------------------------------------

Question 1.5.  Is Linux PD ?  Copyrighted ?

The Linux kernel copyright belongs to Linus Torvalds.  He has placed it
under the GNU General Public Licence, which basically means that you may
freely copy, change and distribute it, but that you may not impose any
restrictions on further distribution.

Full details are in the file COPYING in the Linux kernel sources (probably
in /usr/src/linux on your system).

The copyright of the utilities and programs which come with the
installations vary; much of the code is from the GNU Project at the Free
Software Foundation, and is also under the GPL.

Note that discussion about the merits or otherwise of the GPL should be
posted to gnu.misc.discuss and not to the comp.os.linux groups.

-------------------------------------------------------------------------------

Question 1.6.  How should I pronounce Linux ?

Linus says: `li' is pronounced with a short (ee) sound: compare prInt,
mInImal etc.  `nux' is also short, non-diphtong, like in pUt.  It's partly
due to Minix: Linux was just my working name for the thing, and as I wrote
it to replace Minix on my system, the result is what it is...  Linus'
minix became Linux.

I originally intended it to be called freax (although buggix was one
contender after I got fed up with some of the more persistent bugs :) and
I think the kernel makefiles up to version 0.11 had something to that
effect (`Makefile for the freax kernel' in a comment).  But arl called the
linux directory at nic.funet.fi [now ftp.funet.fi - iwj] pub/OS/Linux, and
the name stuck.  Maybe just as well: freax doesn't sound too good either
(freax is obviosly free + freak + the obligatory -x).

Rik Faith's note for English speakers: Linux --- `LIH-nuhks'.

===============================================================================

Section 2.  Network sources and resources

 Q2.1        Where can I get the HOWTOs and other documentation ?
 Q2.2        What newsgroups are there for Linux ?
 Q2.3        How do I install Linux ?
 Q2.4        Where can I get Linux material by FTP ?
 Q2.5        I don't have FTP access.  Where do I get Linux ?
 Q2.6        I don't have Usenet access.  Where do I get information ?
 Q2.7        What's this mailing list thing at niksula.hut.fi ?
 Q2.8        Are the newsgroups archived anywhere ?

-------------------------------------------------------------------------------

Question 2.1.  Where can I get the HOWTOs and other documentation ?

Look in the following places, and on sites that mirror them.
   ftp.funet.fi (128.214.6.100)   /pub/OS/Linux/doc/HOWTO
   tsx-11.mit.edu (18.172.1.2)    /pub/linux/docs/HOWTO
   sunsite.unc.edu (152.2.22.81)  /pub/Linux/docs/HOWTO
For a complete list of Linux FTP sites see Q2.3 `How do I install Linux
?'.

If you don't have access to FTP try using one of the FTP-by-mail servers,
such as [email-masked] or [email-masked].

A complete list of HOWTO's is available in the file HOWTO.INDEX in the
docs/HOWTO directory at the FTP sites, but here is a (possibly incomplete)
list:

          Installation HOWTO            Electronic Mail HOWTO
          Linux INFO-SHEET              UUCP HOWTO
          Linux META-FAQ                SCSI HOWTO
          NET-2 HOWTO                   Printing HOWTO
          Ethernet HOWTO                Hardware Comaptibility HOWTO
          News HOWTO                    XFree86 HOWTO
          Distribution HOWTO

Some more of these documents are in preparation.  You should check in
nearby directories on the FTP sites if you can't find the answer in one of
the new-style HOWTOs.

The HOWTO.INDEX also contains information on how to write a new HOWTO.

The HOWTOs are coordinated by Matt Welsh, <[email-masked]>.

The `books' produced by the Linux Documentation Project are available in
/pub/Linux/docs/LDP on sunsite.unc.edu.  Please read them if you are new
to Unix and Linux.  Here is a list of those released so far:

          The Linux Documentation Project manifesto
          Installation and Setup Guide for Linux
          The Kernel Hacker's Guide
          Network Administration Guide
          Linux System Administrator's Guide

-------------------------------------------------------------------------------

Question 2.2.  What newsgroups are there for Linux ?

There are five Usenet newsgroups devoted to Linux.

comp.os.linux.announce is the moderated announcements group; you should
read this if you intend to use Linux.  Submissions for that group should
be emailed to [email-masked].

comp.os.linux.help, comp.os.linux.development, comp.os.linux.admin and
comp.os.linux.misc are also worth reading -- you will find that many
common problems are too recent to find in this FAQ but are answered in the
newsgroups.

Since Linux is a Unix clone, many of the comp.unix.* and comp.windows.x.*
groups will also contain relevant material.

Please read Q9.1 `You still haven't answered my question !' before
posting, and make sure you post to the right newsgroup.  Crossposting is
rarely a good idea.

See also Q2.6 `I don't have Usenet access.  Where do I get information ?'.

-------------------------------------------------------------------------------

Question 2.3.  How do I install Linux ?

There are several pre-packaged releases of Linux available, including the
MCC-Interim release, the TAMU release and the Slackware release.  Each
contains the software you need to run linux, ready to install and use.
The exact details of which software is included and how to install them
vary from release to release.

You should read the Installation HOWTO for more details on how to go about
installing Linux.  Note, though, that despite its heavy emphasis on the
SLS release I would strongly recommend against using SLS for any new Linux
installation; you should consider using MCC-Interim, TAMU or Slackware
instead.

All of these releases are available via anonymous FTP from the Linux
archive sites [Q2.4 `Where can I get Linux material by FTP ?'].

-------------------------------------------------------------------------------

Question 2.4.  Where can I get Linux material by FTP ?

There are three main archive sites for Linux:
   ftp.funet.fi (128.214.248.6)   /pub/OS/Linux
   sunsite.unc.edu (152.2.22.81)  /pub/Linux
   tsx-11.mit.edu (18.172.1.2)    /pub/linux
The MCC-Interim release is available from:
   ftp.mcc.ac.uk (130.88.200.7)   /pub/linux
The TAMU release is available from:
   net.tamu.edu (128.194.177.1)   /pub/linux

The contents of these sites is mirrored (copied, usually approximately
daily) by a number of other sites.  Please use one close to you -- that
will be faster for you and easier on the network.
   src.doc.ic.ac.uk                     wuarchive.wustl.edu
                                        ftp.eecs.umich.edu
   ftp.informatik.tu-muenchen.de
   ftp.ibr.cs.tu-bs.de                  monu1.cc.monash.edu.au
   ftp.dfv.rwth-aachen.de               kuis.kyoto-u.ac.jp
   ftp.informatik.rwth-aachen.de        cair.kaist.ac.kr
Not all of these mirror all of the other `source' sites.

-------------------------------------------------------------------------------

Question 2.5.  I don't have FTP access.  Where do I get Linux ?

The easiest thing is probably to find a friend with FTP access.  If there
is a Linux users group near you they may be able to help.

If you have a reasonably good email connection you could try the
FTP-by-mail servers at [email-masked], [email-masked],
[email-masked] or [email-masked].

Linux is also available via traditional mail on diskette, CD-ROM and tape.
The Installation HOWTO, and the file /pub/Linux/docs/distributions on
sunsite.unc.edu, contains information on these distributions.

You could also try Zane Healy <[email-masked]>'s list of Linux BBS's,
which is posted regularly (1st and 15th of each month) to
comp.os.linux.announce and occasionally to the Fidonet and RIME UNIX
echoes.

-------------------------------------------------------------------------------

Question 2.6.  I don't have Usenet access.  Where do I get information ?

Digests of postings to the comp.os.linux.* groups are available by
subscribing to the bidirectional gateway at
[email-masked], where * is one of announce,
development, help, misc or admin.

You are strongly advised to subscribe to at least
[email-masked], as this carries important
information and documentation about Linux.

Please remember to use the -request addresses for your subscription and
unsubscription messages; mail to the other address is posted to the
newsgroup !

-------------------------------------------------------------------------------

Question 2.7.  What's this mailing list thing at niksula.hut.fi ?

It's a multi-channel mailing list, mainly used by the developers of Linux
to talk about technical issues and future developments.  Most of the
channels are not intended for new users to ask their questions on.

The ANNOUNCE channel is a digest of postings to comp.os.linux.announce,
for the benefit of those without Usenet access.  However since
niksula.hut.fi is slow and overloaded I'd recommend subscribing to the MIT
digestifier instead [Q2.6 `I don't have Usenet access.  Where do I get
information ?'].

There is also a NEWBIE channel where `no question is too stupid';
unfortunately it seems that few of the experienced users read that
channel, probably because of all the `stupid' questions !

If you want to subscribe to one or more of the channels at the
multi-channel list, send an empty mail message to
[email-masked] and you'll receive the instructions
for operating the list subscription software.

If you want to unsubscribe send a mail message like this
  From: [email-masked]
  To: [email-masked]
  Subject: irrelevant

  X-Mn-Admin: leave CHANNEL
to leave a channel called CHANNEL.  Do *not* put an X-Mn-Key line in your
message - that will cause it to be posted to the list.

Note that you *must* remember to unsubscribe *before* you change your
email address, as due to a design flaw in the list server it is virtually
impossible to get yourself unsubscribed after such a change.

-------------------------------------------------------------------------------

Question 2.8.  Are the newsgroups archived anywhere ?

Yes.  ftp.funet.fi and tsx-11.mit.edu contain archives of both
comp.os.linux.announce and the old group comp.os.linux, in their Linux
areas.  The comp.os.linux.announce archives are mirrored from /usenet on
src.doc.ic.ac.uk (which also contains another archive of comp.os.linux).

===============================================================================

Section 3.  Compatibility with other operating systems

 Q3.1        Can Linux coexist with DOS ?  OS/2 ?  386BSD ?  Minix ?
 Q3.2        How do I access files on my DOS partition or floppy ?
 Q3.3        Can I use my Stacked/DBLSPC/etc. DOS drive ?
 Q3.4        Can I access OS/2 HPFS, BSD FFS, Mac, Amiga, etc filesystems ?
 Q3.5        Can I run Microsoft Windows programs under Linux ?
 Q3.6        How can I boot Linux from OS/2's Boot Manager ?

-------------------------------------------------------------------------------

Question 3.1.  Can Linux coexist with DOS ?  OS/2 ?  386BSD ?  Minix ?

Yes.  Linux uses the standard PC partitioning scheme, so it can share your
disk with other operating systems.  Then you can use Linux's fdisk to
change the type to Linux.  See the Installation HOWTO for more details.

Linux can read and write the files on your DOS and OS/2 FAT partitions and
floppies using either the DOS filesystem type built into the kernel or
mtools.  There is a DOS emulator (look on tsx-11.mit.edu in
/pub/linux/ALPHA/dosemu) which can run DOS itself and some (but not all)
DOS applications.

Linux can also access Minix filesystems.

-------------------------------------------------------------------------------

Question 3.2.  How do I access files on my DOS partition or floppy ?

Use the DOS filesystem, i.e. type, for example:
        mkdir /dos
        mount -t msdos -o conv=text,umask=022,uid=100,gid=100 /dev/hda3 /dos

You can use the conv=text/binary/auto, umask=nnn, uid=nnn and gid=nnn
options to control the automatic line-ending conversion, permissions and
ownerships of the files in the DOS filesystem as they appear under Linux.
If you mount your DOS filesystem by putting it in your /etc/fstab you can
record the options (comma-separated) there, instead of defaults.

Alternatively you can use `mtools', available in both binary and source
form on the FTP sites -- see Q2.3 `How do I install Linux ?'.

-------------------------------------------------------------------------------

Question 3.3.  Can I use my Stacked/DBLSPC/etc. DOS drive ?

Not easily.  You can access them from within the DOS emulator [Q3.1 `Can
Linux coexist with DOS ?  OS/2 ?  386BSD ?  Minix ?'], but not as a normal
filesystem under Linux or using mtools.

-------------------------------------------------------------------------------

Question 3.4.  Can I access OS/2 HPFS, BSD FFS, Mac, Amiga, etc filesystems ?

There is no support for most of those yet.

There is read-only support for OS/2's HPFS.

-------------------------------------------------------------------------------

Question 3.5.  Can I run Microsoft Windows programs under Linux ?

Not yet.  There is a project, known as WINE, to build an MS Windows
emulator for Linux, but it is not ready for users yet.  Don't ask about it
unless you think you can contribute; look out for the status reports in
comp.os.linux.announce.

The advert from Softlanding (producers of SLS) stating that Linux could
run MS Windows binaries was at best grossly exaggerated; the word `lie'
springs readily to mind.

In the meantime if you need to run MS Windows programs your best bet is
probably to reboot when you want to switch environments.  LILO (the Linux
bootloader) has the facility for a boot menu --- see its documentation for
more details.

-------------------------------------------------------------------------------

Question 3.6.  How can I boot Linux from OS/2's Boot Manager ?

1. Create a partition using OS/2's FDISK (Not Linux's fdisk).

2. Format the partition under OS/2, either with FAT or HPFS. This is so
that OS/2 knows about the partition being formatted.

3. Add the partition to the boot manager.

4. Boot Linux, and create a filesystem on the partition using mkfs -t ext2
or mke2fs.  At this point you may, if you like, use Linux' fdisk to change
the partition type code of the new partition to type 83 (Linux Native) --
this may help some automated installation scripts find the right partition
to use.

5. Install Linux on the partition.

6. Install LILO on the Linux partition -- NOT on the master boot record of
the hard drive.  This installs LILO as a second-stage boot loader on the
Linux partition itself, to start up the kernel specified in the LILO
config file.  To do this you should put
   boot = /dev/hda2
(where /dev/hda2 is the *partition* you want to boot off) in your
/etc/lilo/config or /etc/lilo.config file.

===============================================================================

Section 4.  Linux's handling of filesystems, disks and drives

 Q4.1        How do I format and create a filesystem on a floppy ?
 Q4.2        I get nasty messages about inodes, blocks, and the suchlike
 Q4.3        My swap area isn't working.
 Q4.4        How can I have more than 16Mb of swap ?
 Q4.5        How do I remove LILO so my system boots DOS again ?
 Q4.6        Why can't I use fdformat except as root ?
 Q4.7        Is there something like Stacker or Doublespace for Linux ?

-------------------------------------------------------------------------------

Question 4.1.  How do I format and create a filesystem on a floppy ?

For a 3.5 inch high density floppy:
   fdformat /dev/fd0H1440
   mkfs -t ext2 /dev/fd0H1440 1440
For a 5.25 floppy inch use fd0h1200 and 1200 as appropriate.  For the `B'
drive use fd1 instead of fd0.  Full details of which floppy devices do
what can be found in the Linux Device List [Q2.1 `Where can I get the
HOWTOs and other documentation ?'].  If you don't have the fsutils package
you'll have to run mke2fs instead of mkfs -t ext2.

The first command low-level formats the floppy; the second creates an
empty filesystem on it.  After doing this you can mount the floppy like a
hard disk partition and simply cp and mv files, etc.

-------------------------------------------------------------------------------

Question 4.2.  I get nasty messages about inodes, blocks, and the suchlike

You probably have a corrupted filesystem, probably caused by not shutting
Linux down properly before turning off the power or resetting.  You need
to use a recent shutdown program to do this --- for example, the one
included in the bootutils package, available on sunsite and tsx-11.

If you're lucky the program fsck (or e2fsck or xfsck as appropriate if you
don't have the fsutils package) will be able to repair your filesystem; if
you're unlucky the filesystem is trashed and you'll have to reinitialise
it with mkfs (or mke2fs, mkxfs etc.) it and restore from a backup.

NB don't try to check a filesystem that's mounted read-write - this
includes the root partition if you don't see
   VFS: mounted root ... read-only
at boot time.

-------------------------------------------------------------------------------

Question 4.3.  My swap area isn't working.

When you boot (or enable swapping manually) you should see
        Adding Swap: NNNNk swap-space

If you don't see any messages at all you are probably missing swapon -av
(the command to enable swapping) in your /etc/rc or /etc/rc.local (the
system startup scripts), or have forgotten to make the right entry in
/etc/fstab:
        /dev/hda2       none       swap       sw
for example.

If you see
        Unable to find swap-space signature
you have forgotten to run mkswap.  See the manpage for details; it works
much like mkfs.

Check the Installation HOWTO for detailed instructions of how to set up a
swap area.

-------------------------------------------------------------------------------

Question 4.4.  How can I have more than 16Mb of swap ?

Use a recent kernel -- From at least 0.99.14 Linux can have swap
partitions of up to 128Mb.

If you use an older kernel you have to set up more than one swap partition
or swapfile.  Linux only supports swap area sizes up to 16Mb, but you can
set up and configure several swap areas and Linux will use them all.

-------------------------------------------------------------------------------

Question 4.5.  How do I remove LILO so my system boots DOS again ?

Using DOS (MS-DOS 5.0 or later, or OS/2), type FDISK /MBR.  This will
restore a standard MS-DOS Master Boot Record.  If you have DR-DOS 6.0, go
into FDISK in the normal way and then select the `Re-write Master Boot
Record' option.

If you don't have DOS 5 or DR-DOS you need to have the boot sector that
LILO saved when you first installed it.  You did keep that file, didn't
you ?  It's probably called boot.0301 or some such.  Type
        dd if=boot.0301 of=/dev/hda
(or sda if you're using a SCSI disk).  This will also wipe out your
partition table, so beware !

Note that the DOS MBR boots whichever (single!) partition is flagged as
`active'; you may need to use fdisk to set and clear the active flags on
partitions appropriately.

-------------------------------------------------------------------------------

Question 4.6.  Why can't I use fdformat except as root ?

The system call to format a floppy may only be done as root, regardless of
the permissions of /dev/fd0*.  If you want any user to be able to format a
floppy try getting the fdformat2 program; this works around the problems
by being setuid to root.

-------------------------------------------------------------------------------

Question 4.7.  Is there something like Stacker or Doublespace for Linux ?

Currently none of the Linux filesystems can do compression in the
filesystem.

There is a transparently uncompressing C library, which is a drop-in
replacement for the standard C library.  It allows programs to read
compressed (ie, GNU zipped) files as if they were not compressed.  You
install it, and then you can compress files using gzip and have programs
still find them.  Look on sunsite.unc.edu in /pub/Linux/libs.  The author
is Alan Knaff <[email-masked]>.

There is also a package available called tcx (Transparently Compressed
Executables) which allows you to keep infrequently used executables
compressed and only uncompress them temporarily while you use them.
You'll find it on the Linux FTP sites [Q2.4 `Where can I get Linux
material by FTP ?']; it was also announced in comp.os.linux.announce.
Note - this is not the same as gzexe, which is an inferior implementation
of the same concept.

===============================================================================

Section 5.  Porting, compiling and obtaining programs

 Q5.1        What is ld.so and where do I get it ?
 Q5.2        Has anyone ported / compiled / written XXX for Linux ?
 Q5.3        How do I port XXX to Linux ?
 Q5.4        Can I use code or a compiler compiled for a 486 on my 386 ?
 Q5.5        GCC sometimes uses huge amounts of virtual memory and thrashes
 Q5.6        What does gcc -O6 do ?
 Q5.7        Where are <linux/*.h> and <asm/*.h> ?
 Q5.8        I get errors when I try to compile the kernel.

-------------------------------------------------------------------------------

Question 5.1.  What is ld.so and where do I get it ?

ld.so is the new dynamic library loader.  Each binary using shared
libraries used to have about 3K of start-up code to find and load the
shared libraries.  Now that code has been put in a special shared library,
/lib/ld.so, where all binaries can look for it, so that it wastes less
disk space, and can be upgraded more easily.

It can be obtained from tsx-11.mit.edu in /pub/linux/packages/GCC and
mirror sites thereof.  The latest version at the time of writing is
ld.so.1.3.tar.gz.

-------------------------------------------------------------------------------

Question 5.2.  Has anyone ported / compiled / written XXX for Linux ?

First, look in the Linux Software Map (LSM) --- it's in the docs directory
on sunsite.unc.edu, and on the other FTP sties.

Check the FTP sites (see Q2.1 `Where can I get the HOWTOs and other
documentation ?') first --- search the find-ls or INDEX files for
appropriate strings.

If you don't find anything, you could either download the sources to the
program yourself and compile them -- see Q5.3 `How do I port XXX to Linux
?' -- or, if it's a large package which may require some porting, post a
message to the newsgroup.

If you compile a largeish program please upload it to one or more of the
FTP sites and post a message to comp.os.linux.announce (submit your
posting to [email-masked]).

If you're looking for an application-type program the chances are someone
has already written a free verson.  Try reading the FAQ in
comp.sources.wanted for instructions on how to find sources.

-------------------------------------------------------------------------------

Question 5.3.  How do I port XXX to Linux ?

In general Unix programs need very little porting.  Simply follow the
installation instructions.  If you don't know and don't know how to find
out the answers to some of the questions asked during or by the
installation procedure you can guess, but this tends to produce buggy
programs.  In this case you're probably better off asking someone else to
do the port.

If you have a BSD-ish program you should try using -I/usr/include/bsd and
-lbsd on the appropriate parts of the compilation lines.

-------------------------------------------------------------------------------

Question 5.4.  Can I use code or a compiler compiled for a 486 on my 386 ?

Yes.

The -m486 option to GCC, which is used to compile binaries for 486
machines, merely makes GCC change certain optimisations.  This makes for
slightly larger binaries which run somewhat faster on a 486.  They still
work fine on a 386, though, with little performance hit.

GCC can be configured for a 386 or 486; the only difference is that
configuring it for a 386 makes -m386 the default and configuring for a 486
makes -m486 the default; in either case these can be overriden on a
per-compilation basis or by editing /usr/lib/gcc-lib/i*-linux/n.n.n/specs.

-------------------------------------------------------------------------------

Question 5.5.  GCC sometimes uses huge amounts of virtual memory and thrashes

GCC has a bug which makes it use lots of memory if you try to compile a
program which has a large static data table in it.  Add more swap if
necessary and just grin and bear it; it'll work in the end.

This bug will be fixed when GCC 2.5 comes out.

-------------------------------------------------------------------------------

Question 5.6.  What does gcc -O6 do ?

The same as -O2; any number greater than 2 works just like 2.  It's put
there for luck, I think.

-------------------------------------------------------------------------------

Question 5.7.  Where are <linux/*.h> and <asm/*.h> ?

These are in the directories /usr/include/linux and /usr/include/asm.

However they should be symbolic links to your kernel sources in
/usr/src/linux and not real directories.

If you don't have the kernel sources download them --- see Q6.15 `How do I
upgrade my kernel ?'.

Then use ln to create the links:
        ln -sf /usr/src/linux/include/linux /usr/include/linux
        ln -sf /usr/src/linux/include/asm /usr/include/asm

-------------------------------------------------------------------------------

Question 5.8.  I get errors when I try to compile the kernel.

Make sure that /usr/include/linux and /usr/include/asm aren't actual
directories but instead symbolic links to /usr/src/linux/include/linux and
/usr/src/linux/include/asm respectively.

If necessary, delete them using rm and then use ln -s to make the links as
in Q5.7 `Where are <linux/*.h> and <asm/*.h> ?'.

===============================================================================

Section 6.  Miscellaneous questions and problems

 Q6.1        Setuid scripts don't seem to work.
 Q6.2        Free memory as reported by free keeps shrinking.
 Q6.3        What is a BogoMip ?
 Q6.4        How do I set the timezone ?
 Q6.5        What version of Linux and what machine name am I using ?
 Q6.6        When I add more memory it slows to a crawl.
 Q6.7        Some programs (e.g. xdm) won't let me log in.
 Q6.8        Some programs let me log in with no password.
 Q6.9        My machine runs very slowly when I run GCC / X / ...
 Q6.10       I can only log in as root.
 Q6.11       How do I stop producing core files ?
 Q6.12       My screen is all full of weird characters instead of letters.
 Q6.13       What is a .gz file ? And a .tgz ? And ... ?
 Q6.14       I have screwed up my system and can't log in to fix it.
 Q6.15       How do I upgrade my kernel ?
 Q6.16       Can I have more than 3 serial ports by sharing interrupts ?
 Q6.17       Emacs just dumps core.
 Q6.18       How do I make a bootable floppy ?
 Q6.19       How do I remap my keyboard to UK, French, etc. ?

-------------------------------------------------------------------------------

Question 6.1.  Setuid scripts don't seem to work.

That's right.  This feature has been specifically disabled in the Linux
kernel because setuid scripts are almost always a security hole.  If you
want to know why read the FAQ for comp.unix.questions.

-------------------------------------------------------------------------------

Question 6.2.  Free memory as reported by free keeps shrinking.

The `free' figure printed by free doesn't include memory used as a disk
buffer cache - shown in the `buffers' column.  If you want to know how
much memory is really free add the `buffers' amount to `free'.

The disk buffer cache tends to grow soon after starting Linux up, as you
load more programs and use more files and the contents get cached.  It
will stabilise after a while.

-------------------------------------------------------------------------------

Question 6.3.  What is a BogoMip ?

`BogoMips' is a contraction of `Bogus MIPS'.  MIPS stands for (depending
who you listen to) Millions of Instructions per Second, or Meaningless
Indication of Processor Speed.

The number printed at boot-time is the result of a kernel timing
calibration, used for delay loops by some device drivers.

As a very approximate guide for a 486DX (not clock doubled), the BogoMips
will be approximately the clock rate * 0.5; for a 386DX (no coprocessor)
it will be more like the clock rate * 0.24 - 1.9.

If the number you're seeing is wildly lower than this you may have the
Turbo button or CPU speed set incorrectly, or have some kind of caching
problem [as described in Q6.6 `When I add more memory it slows to a
crawl.'.]

-------------------------------------------------------------------------------

Question 6.4.  How do I set the timezone ?

Change directory to /usr/lib/zoneinfo; get the timezone package if you
don't have this directory.  The source can be found on sunsite.unc.edu in
/pub/Linux/system/Admin/timesrc-1.2.tar.gz.

Then make a symbolic link named localtime pointing to one of the files in
this directory (or a subdirectory), and one called posixrules pointing to
localtime.  For example:
   ln -sf US/Mountain localtime
   ln -sf localtime posixrules
This change will take effect immediately - try date.

Don't try to use the TZ variable - leave it unset.

-------------------------------------------------------------------------------

Question 6.5.  What version of Linux and what machine name am I using ?

Type:
   uname -a

-------------------------------------------------------------------------------

Question 6.6.  When I add more memory it slows to a crawl.

This is quite a common symptom of a failure to cache the additional
memory.  The exact problem depends on your motherboard.

Sometimes you have to enable caching of certain regions in your BIOS
setup.  Look in the CMOS setup and see if there is an option to cache the
new memory area which is currently switched off.  This is apparently most
common on a 486.

Sometimes the RAMs have to be in certain sockets to be cached.

Sometimes you have to set jumpers to enable the caching.

Some motherboards don't cache all the RAM if you have more RAM per amount
of cache than they expect.  Usually a full 256K cache will solve this
problem.

If in doubt, check your motherboard manual.  If you still can't fix it
because the documentation is inadequate you might like to post a message
giving *all* the details - make, model number, date code, etc. so that
other Linux users can avoid it.

-------------------------------------------------------------------------------

Question 6.7.  Some programs (e.g. xdm) won't let me log in.

You are probably using non-shadow-password programs but are using shadow
passwords.

If so, you have to get or compile a shadow password version of the
program(s) in question.  The shadow password suite can be found in
(amongst other places):
   tsx-11.mit.edu:/pub/linux/sources/usr.bin/shadow-*
This is the source code; you will probably find the binaries in
.../linux/binaries/usr.bin.

-------------------------------------------------------------------------------

Question 6.8.  Some programs let me log in with no password.

You probably have the same problem as in Q6.7 `Some programs (e.g. xdm)
won't let me log in.', with an added wrinkle:

If you are using shadow passords you should put an asterisk in the
password field of /etc/passwd for each account, so that if a program
doesn't know about the shadow passwords it won't think it's a passwordless
account and let anyone in.

-------------------------------------------------------------------------------

Question 6.9.  My machine runs very slowly when I run GCC / X / ...

You probably don't have any swap enabled.  You need to enable swapping to
allow Linux to page out bits of data programs aren't using at the moment
to disk to make more room for other programs and data.  If you don't Linux
has to keep data in memory and throw away in-memory copies of programs
(which are paged straight from the filesystem) and so less and less
program is in memory and everything runs very slowly.

See the Installation HOWTO and the Installation and Getting Started Guide
[Q2.1 `Where can I get the HOWTOs and other documentation ?'] for details
of how to set up a swap area; see also Q4.3 `My swap area isn't working.'.

Alternatively you may have too little real memory.  If you have less RAM
than all the programs you're running at once use Linux will use your hard
disk instead and thrash horribly.  The solution in this case is to not run
so many things at once or to buy more memory.  You can also reclaim some
memory by compiling and using a kernel with less options configured.  See
Q6.15 `How do I upgrade my kernel ?'.

-------------------------------------------------------------------------------

Question 6.10.  I can only log in as root.

You probably have some permission problems, or you have a file
/etc/nologin.

If the latter put rm -f /etc/nologin in your /etc/rc or /etc/rc.local.

Otherwise check the permissions on your shell, and any filenames which
appear in error messages, and also the directories containing these files
all the way back up the tree to the root directory.

-------------------------------------------------------------------------------

Question 6.11.  How do I stop producing core files ?

If you use bash put
   ulimit -c 0
in your .shrc or .bashrc; if you use tcsh put
   limit coredumpsize 0
in your .cshrc.  For other shells check the shell's manpage.

-------------------------------------------------------------------------------

Question 6.12.  My screen is all full of weird characters instead of letters.

You probably sent some binary data to your screen by mistake.  Type echo
^V^O (that's E C H O space control-V control-O return) to fix it.

-------------------------------------------------------------------------------

Question 6.13.  What is a .gz file ? And a .tgz ? And ... ?

.gz (and .z) files have been compressed using GNU gzip.  You have to get a
copy of gunzip (included in the gzip distribution and with most Linux
installations) to unpack the file.

.taz and .tz are tarfiles (made with Unix tar) compressed using standard
Unix compress.

.tgz (or .tpz) is a tarfile compressed with gzip.

The file command can often tell you what a file is.

If you find that gzip complains when you try to uncompress a gzipped file
you probably downloaded it in ASCII mode by mistake.  You must download
most things in binary mode - remember to type binary as a command in FTP
before using get to get the file.

-------------------------------------------------------------------------------

Question 6.14.  I have screwed up my system and can't log in to fix it.

Reboot from an emergency floppy, for example the SLS a1 disk or the MCC
installation boot floppy.  Get to a shell prompt and mount your hard disk
with something like
        mount -t ext2 /dev/hda1 /mnt

Then your filesystem is available under the directory /mnt and you can fix
the problem.  Remember to unmount your hard disk before rebooting (cd back
down to / first or it will say it's busy).

-------------------------------------------------------------------------------

Question 6.15.  How do I upgrade my kernel ?

See the README which comes with the kernel release, in
        ftp.funet.fi:/pub/OS/Linux/PEOPLE/Linus
and mirrors thereof.  Try to get it from a closer site if possible;
ftp.funet.fi is a very busy site and therefore slow -- see Q2.3 `How do I
install Linux ?'.

Remember that to make the new kernel boot you must run LILO after copying
the kernel into your root partition.

-------------------------------------------------------------------------------

Question 6.16.  Can I have more than 3 serial ports by sharing interrupts ?

Not without some trickery.  This is a limitation of the ISA bus
architecture.

See the Serial HOWTO for information about how to work around this
problem.

-------------------------------------------------------------------------------

Question 6.17.  Emacs just dumps core.

You probably have the X version of Emacs that comes with SLS.  It doesn't
work without the X libraries.  The solution is to install X Windows or get
a newer Emacs binary without any X Windows support.

-------------------------------------------------------------------------------

Question 6.18.  How do I make a bootable floppy ?

Make a filesystem on it with bin, etc and lib directories -- everything
you need.  Install a kernel on it and arrange to have LILO boot it from
the floppy (see the LILO documentation, in lilo.u.*.ps).

If you build the kernel (or tell LILO to tell the kernel) to have a
ramdisk the same size as the floppy the ramdisk will be loaded at
boot-time and mounted as root in place of the floppy.

-------------------------------------------------------------------------------

Question 6.19.  How do I remap my keyboard to UK, French, etc. ?

For recent kernels, get kbd*.tar.gz from the same place as you got the
kernel source.  Make sure you get the appropriate version; you have to use
the right keyboard-mapping package to go with your kernel version.  The
latest at the time of writing is kbd-0.81.tar.gz, which works with kernel
versions from 0.99pl12 to at least 0.99pl14.

For older kernels you have to edit the top-level kernel Makefile, in
/usr/src/linux.

===============================================================================

Section 7.  Frequently Encountered Error messages

 Q7.1        INET: Warning: old style ioctl(IP_SET_DEV) called!
 Q7.2        ld: unrecognized option '-m486'
 Q7.3        GCC says Internal compiler error
 Q7.4        make says Error 139
 Q7.5        df says Cannot read table of mounted filesystems
 Q7.6        shell-init: permission denied when I log in.
 Q7.7        No utmp entry.  You must exec ... when I log in.
 Q7.8        EXT2-fs: warning: mounting unchecked filesystem
 Q7.9        fdisk says cannot use nnn sectors of this partition
 Q7.10       fdisk says partition n has an odd number of sectors

-------------------------------------------------------------------------------

Question 7.1.  INET: Warning: old style ioctl(IP_SET_DEV) called!

You are trying to use the old network configuration utilities; the new
ones can be found on tsx-11.mit.edu in
/pub/linux/packages/net/net-2/binaries.

Note that they cannot be used just like the old-style programs; see the
NET-2 HOWTO for instructions on how to set up networking correctly.

-------------------------------------------------------------------------------

Question 7.2.  ld: unrecognized option '-m486'

You have an old version of ld.  Install a newer binutils package -- this
will contain an updated ld:
   tsx-11.mit.edu:/pub/linux/packages/GCC/binutils.tar.z

-------------------------------------------------------------------------------

Question 7.3.  GCC says Internal compiler error

If the fault is repeatable (ie, it always happens at the same place in the
same file) you have discovered a bug in GCC.  See the GCC Info
documentation (type Control-h i in Emacs, and select GCC from the menu)
for details on how to report this -- make sure you have the latest version
though.

Note that this is probably not a Linux-specific problem; unless you were
compiling a program many other Linux users also compile you should not
post your bug report to any of the comp.os.linux groups.

If the problem is not repeatable you are very probably experiencing memory
corruption --- see Q7.4 `make says Error 139'.

-------------------------------------------------------------------------------

Question 7.4.  make says Error 139

Your compiler driver (gcc) dumped core.  You probably have a buggy or old
version of GCC --- get the latest release.

If this doesn't fix the problem you are probably having problems with
memory corruption.  Check that the clock rate, wait states and refresh
timing for your SIMMs are correct.  If so you may have some dodgy SIMMs.
Linux, like any Unix, is a very good memory tester.

-------------------------------------------------------------------------------

Question 7.5.  df says Cannot read table of mounted filesystems

There is probably something wrong with your /etc/mtab or /etc/fstab files.
If you have a reasonably new version of mount, /etc/mtab should be emptied
or deleted at boot time (in /etc/rc or /etc/rc.local), using something
like
   rm -f /etc/mtab*

Some versions of SLS have an entry for the root partition in /etc/mtab
made in /etc/rc by using rdev.  This is incorrect -- the newer versions of
mount do this automatically.

Other versions of SLS have a line in /etc/fstab that looks like:
    /dev/sdb1   /root   ext2   defaults
This is wrong.  /root should read simply /.

-------------------------------------------------------------------------------

Question 7.6.  shell-init: permission denied when I log in.

Your root directory and all the directories up to your home directory must
be readable and executable by everybody.  See the manpage for chmod or a
book on Unix for how to fix the problem.

-------------------------------------------------------------------------------

Question 7.7.  No utmp entry.  You must exec ... when I log in.

Your /etc/utmp is screwed up.  You should have
   > /etc/utmp
in your /etc/rc or /etc/rc.local.  See Q6.14 `I have screwed up my system
and can't log in to fix it.' for how to be able to do this.

-------------------------------------------------------------------------------

Question 7.8.  EXT2-fs: warning: mounting unchecked filesystem

You need to run e2fsck (or fsck -t ext2 if you have the fsutils package)
with the -a option to get it to clear the `dirty' flag, and then cleanly
unmount the partition during each shutdown.

The easiest way to do this is to get the bootutils package, available on
sunsite and tsx-11.

NB don't try to check a filesystem that's mounted read-write - this
includes the root partition if you don't see
   VFS: mounted root ... read-only
at boot time.

-------------------------------------------------------------------------------

Question 7.9.  fdisk says cannot use nnn sectors of this partition

Originally Linux only supported the Minix filesystem, which cannot use
more than 64Mb per parition.  This limitation is not present in the more
advanced filesystems now available, such as ext2fs (the 2nd version of the
Extended Filesystem) and xiafs (Qi Xia's filesystem).

If you intend to use ext2fs or xiafs you can ignore the message.

-------------------------------------------------------------------------------

Question 7.10.  fdisk says partition n has an odd number of sectors

The PC disk partitioning scheme works in 512-byte sectors, but Linux uses
1K blocks.  If you have a partition with an odd number of sectors the last
sector is wasted.  Ignore the message.

===============================================================================

Section 8.  X Windows

 Q8.1        Does Linux support X Windows ?
 Q8.2        Where can I get an XConfig for my video card and monitor ?
 Q8.3        I can't get X Windows to work right.

-------------------------------------------------------------------------------

Question 8.1.  Does Linux support X Windows ?

Yes.  You need to have a video card which is supported by XFree86 2.0.
See the Linux XFree86 HOWTO for more details.

Some of the Linux releases -- MCC, for example -- don't come with X
Windows already included; however you can easily download and install it
from /pub/Linux/X11/Xfree86-2.0 on sunsite.unc.edu and its mirror sites.
Read the XFree86 HOWTO for installation instructions.

Other releases -- TAMU, Slackware and SLS, for example -- come with X
Windows already included

-------------------------------------------------------------------------------

Question 8.2.  Where can I get an XConfig for my video card and monitor ?

It's not that hard to roll your own -- read the instructions that came
with XFree86-2.0, in /usr/X386/lib/X11/etc.  The file you probably most
need to look at is README.Config.  See also the Linux XFree86 HOWTO.

-------------------------------------------------------------------------------

Question 8.3.  I can't get X Windows to work right.

Read the XFree86 HOWTO - note the question and answer section.

Try reading to comp.windows.x.i386unix -- specifically read the the FAQ
for that group.

Please don't post X Windows or XFree86 related questions to
comp.os.linux.help unless they are Linux-specific.

===============================================================================

Section 9.  How to get further assistance

 Q9.1        You still haven't answered my question !
 Q9.2        What to put in a posting to comp.os.linux.help

-------------------------------------------------------------------------------

Question 9.1.  You still haven't answered my question !

Please read all of this answer before posting.  I know it's a bit long,
but you may be about to make a fool of yourself in front of 50000 people
and waste hundreds of hours of their time.  Don't you think it's worth it
to spend some of your time reading and following these instructions ?

If you think an answer is incomplete or inaccurate, please mail Ian
Jackson at <[email-masked]>.

Read the appropriate Linux Documentation Project books - see Q2.1 `Where
can I get the HOWTOs and other documentation ?'.

If you're a Unix newbie read the FAQ for comp.unix.questions, and those
for any of the other comp.unix.* groups that may be relevant.

Linux is a Unix clone, so almost everything you read there will apply to
Linux.  Those FAQs can, like all FAQs, be found on rtfm.mit.edu in
/pub/usenet/news.answers.

Check the relevant HOWTO for the subject in question, if there is one, or
an appropriate old-style sub-FAQ document.  Check the FTP sites.

Try experimenting --- that's the best way to get to know Unix and Linux.

Read the documentation.  Check the manpages (type man man if you don't
know about manpages) and the Info documentation (type C-h i, i.e. Control
H followed by I in Emacs) --- NB this isn't just for Emacs; for example
the GCC documentation lives here as well.  There will also often be a
README file with a package giving installation and/or usage instructions.

Make sure that you don't have a corrupted or out-of-date copy of the
program in question.  If possible, download it again and reinstall it ---
perhaps you made a mistake the first time.

Read comp.os.linux.announce --- this often contains very important
information for all Linux users.

X-Windows questions belong in comp.windows.x.i386unix, not in
comp.os.linux.help.  But read the group first (including the FAQ), before
you post !

Only if you have done all of these things and are still stuck should you
post to comp.os.linux.help; alternatively you could send email to
[email-masked].  Make sure you read the next question, Q9.2
`What to put in a posting to comp.os.linux.help', first.

-------------------------------------------------------------------------------

Question 9.2.  What to put in a posting to comp.os.linux.help

Please read carefully the following advice about how to write your
posting.  Taking heed of it will greatly increase the chances that an
expert and/or fellow user reading your posting will have enough
information and motivation to reply.

Make sure you give full details of the problem, including

* What program, exactly, you are having problems with.  Include the
  version number if known and say where you got it.  Many standard
  commands tell you their version number if you give them a --version
  option.

* Which Linux release you're using (MCC, Slackware, whatever) and what
  version of that release.

* The *exact* and *complete* text of any error messages printed.

* Exactly what behaviour you were expecting, and exactly what behaviour
  you observed.  A transcript of an example session is a good way of
  showing this.

* The contents of any configuration files used by the program in question
  and any related programs.

* What version of the kernel and of the shared libraries you are using.
  The kernel version can be found by typing uname -a, and the shared
  library version by typing ls -l /lib/libc.so.4.

* Details of what hardware you're running on, if it seems appropriate.

You are in little danger of making your posting too long unless you
include large chunks of source code or uuencoded files, so err on the side
of giving too much information.

Use a clear, detailed Subject line.  Don't put things like `doesn't work',
`Linux', `help' or `question' in it --- we already knew that ! Save the
space for the name of the program, a fragment of the error message,
summary of the unusual behaviour, etc.

If you are reporting an `unable to handle kernel paging request' message,
follow the instructions in the Linux kernel sources README for turning the
numbers into something more meaningful.  If you don't do this noone who
reads your post will be able to do it for you, as the mapping from numbers
to function names varies from one kernel to another.

Put a summary paragraph at the top of your posting.

At the bottom of your posting, ask for responses by email and say you'll
post a summary.  Back this up by using Followup-To: poster.  Then, do
actually post a summary in a few days or a week or so.  Don't just
concatenate the replies you got --- summarise.  Putting the word SUMMARY
in your summary's Subject line is also a good idea.

Make sure your posting doesn't have an inappropriate References header
line.  This marks your article as part of the thread of the article
referred to, which will often cause it to be junked by the readers with
the rest of a boring thread.  If you use (t)rn you must make sure that
when you post you use the lowercase f key; using uppercase F and deleting
the quoted text doesn't do the same thing.  However Some versions of trn
2.x have a bug which produces this effect effen if you use f.  If this
applies to your version you can edit out the References line in the
message before you post, or just use plain Pnews to make a new posting.
You should always read the header before posting anyway.

Finally, remember that you should not post email sent to you personally
without the sender's permission.

===============================================================================

Section 10.  Administrative information and acknowledgements

 Q10.1       Feedback is invited
 Q10.2       Formats in which this FAQ is available
 Q10.3       Authorship and acknowledgements

-------------------------------------------------------------------------------

Question 10.1.  Feedback is invited

Please send me your comments on this FAQ.

I accept submissions for the FAQ in any format;  All contributions
comments and corrections are gratefully received.

Please send them to <[email-masked]>.

-------------------------------------------------------------------------------

Question 10.2.  Formats in which this FAQ is available

This document is available as ASCII text, an Emacs Info document and
PostScript.

The ASCII and Emacs Info versions and a Lout typesetter file (from which
the PostScript is produced) are generated automatically by a Perl script
which takes as input a file in the Bizarre Format with No Name.

The output files linux-faq.ascii, .info and .ps and a tarfile
linux-faq.source.tar.gz, containing the BFNN source and Perl script
converter, are available in the docs directories of the major Linux FTP
sites.

-------------------------------------------------------------------------------

Question 10.3.  Authorship and acknowledgements

This FAQ was compiled by Ian Jackson <[email-masked]>, with
assistance and comments from others too numerous to mention.  It was
loosely based on the original Linux FAQ by Marc-Michel Corsini.

Special thanks are due to Matt Welsh, who coordinates the HOWTOs and has
written substantial portions of many of them, and to Marc-Michel Corsini.
Thanks also to the contributors to the previous Linux FAQ, and to those
sent me comments about this FAQ, and who answered questions on the
newsgroup.

Last but not least, thanks to Linus Torvalds and the other contributors to
Linux for giving us something to write about !

-- 
Ian Jackson, at home  <[email-masked]> or <[email-masked]>
PGP2 public key available on server.  Urgent email: <[email-masked]>
2 Lexington Close, Cambridge, CB4 3LS, England;  phone: +44 223 64238